;===============================================================================
;
; learnable rage 2.0
;
; - automatically learn rages after battle
; - disable leap
;
;===============================================================================

header
hirom

!rage_user = #$0B           ;rager ID

;===============================================================================
;
; - make leap miss
; - learn rages
;
;===============================================================================
org     $C23B71

leap_miss: ;--------------------------------------------------------------------

    ;make leap miss
        JMP $3B90

rage_learn: ;-------------------------------------------------------------------

    ;check if rager is in party

        JSL rage_check      ;check if rager in party
        LDA $EE             ;flag from rage check
        BPL .exit           ;skip learning of rages without rager

    ;learn rages
        JSR $4A07           ;learn all available rages

    ;exit
    .exit
        LDA $300A           ;mog's presence, used in following code
        RTS                 ;exit

warnpc  $C33B90

;===============================================================================
;
; disable leap command
;
;===============================================================================
org     $C2543E
leap_null:

    ;disable leap command in battle
        JMP $5434

warnpc  $C25445

;===============================================================================
;
; learn rages link
;
;===============================================================================
org     $C25EE5
rage_learn_link:

    ;update rages
        JSR rage_learn

warnpc  $C25EE8

;===============================================================================
;
; check if valid rager in party
;
;===============================================================================
org     $C3FA00                 ;(*) change for start of free address
rage_check:

    ;init
        PHX                     ;backup X
        PHP                     ;backup status
        SEP #$30                ;mode 1AB, 1XY
        STZ $EE                 ;null rager flag
        LDX #$06                ;max party member

    ;check party member ID
    .loop
        LDA $3ED8,X             ;character ID
        CMP !rage_user          ;rager id
        BNE .next               ;skip if not rager or undefined

    ;check party member status
        LDA $3EE4,X             ;char status
        BIT #$C2                ;dead, zombie, petrify
        BNE .next               ;don't learn rages if status are set
        
    ;flag rages to be learned
        LDA #$FF                ;learn rages flag
        STA $EE                 ;save it

    ;check next party member
    .next                       ;get next char
        DEX
        DEX
        BPL .loop

    ;exit
        PLP
        PLX
        RTL

warnpc  $C3FA21                 ;(*) change for end of free address
